%define anolis_release 1
%global _hardened_build 1

Summary: Tools and scripts for creating debuginfo and source file distributions, collect build-ids and rewrite source paths in DWARF data for debugging, tracing and profiling.
Name: debugedit
Version: 5.1
Release: %{anolis_release}%{?dist}

License: GPL-3.0-or-later AND GPL-2.0-or-later AND LGPL-2.0-or-later
URL: https://sourceware.org/debugedit/
Source0: https://sourceware.org/pub/%{name}/%{version}/%{name}-%{version}.tar.xz

BuildRequires: make, gcc > 12.0, help2man, dwz, autoconf, automake
BuildRequires: pkgconfig(libelf), pkgconfig(libdw)
BuildRequires: help2man, gnupg2, xxhash-devel, xxhash-static

Requires: elfutils, binutils, findutils, gawk, coreutils, xz
Requires: /usr/bin/gdb-add-index
Suggests: gdb-minimal
Requires: sed, dwz, grep

# https://sourceware.org/git?p=debugedit.git;a=commit;h=971a74d79b48a19ff1446642f39b3c5a8a7db238
Patch1: 0001-find-debuginfo-Check-files-are-writable-before-modif.patch
# https://sourceware.org/git?p=debugedit.git;a=commit;h=64d61a5f7d0ed685880f5c4f4b91f967445ba3a9
Patch2: 0001-find-debuginfo-Fix-skip_mini-.gnu_debugdata-handling.patch
# https://sourceware.org/git?p=debugedit.git;a=commit;h=b9a4cbf363946b3d27a3cacd556618378e42b5ca
Patch3: 0001-find-debuginfo-Make-return-from-do_file-explicit.patch

%description
%{name} is a tool used for debugging programs in Linux. It allows
developers to view and modify debugging information associated with
ELF (Executable Linkable Format) files. This tool enables developers
to track down software bugs by identifying and manipulating the source
code or binary files at runtime. %{name} provides a set of commands
that allow developers to analyze and manipulate the symbol table, source
files, and line number information in ELF files.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
autoreconf -ivf
%configure
%make_build

%install
%make_install

cd %{buildroot}%{_bindir}
ln -s find-debuginfo find-debuginfo.sh
%generate_compatibility_deps

%check
%ifnarch loongarch64
%make_build check
%endif

%files
%license COPYING COPYING3 COPYING.LIB
%dir %{abidir}
%{_bindir}/debugedit
%{abidir}/debugedit-option.list
%{_bindir}/sepdebugcrcfix
%{abidir}/sepdebugcrcfix-option.list
%{_bindir}/find-debuginfo
%{abidir}/find-debuginfo-option.list
%{_bindir}/find-debuginfo.sh
%{_mandir}/man1/debugedit.1*
%{_mandir}/man1/sepdebugcrcfix.1*
%{_mandir}/man1/find-debuginfo.1*

%files doc 
%doc README

%changelog
* Fri Feb 28 2025 Zhao Hang <wb-zh951434@alibaba-inc.com> - 5.1-1
- Update to 5.1-1 from 5.0-7
- Migrated to SPDX license
- Remove patches which is already exist in code
- Add 0001-find-debuginfo-Check-files-are-writable-before-modif.patch, 
  0001-find-debuginfo-Fix-skip_mini-.gnu_debugdata-handling.patch
  and 0001-find-debuginfo-Make-return-from-do_file-explicit.patch
  [Patches cherry-pick from c10s. Original changelog:
  - Add 0001-find-debuginfo-Check-files-are-writable-before-modif.patch
  - Add 0001-find-debuginfo-Fix-skip_mini-.gnu_debugdata-handling.patch
  - Add 0001-find-debuginfo-Make-return-from-do_file-explicit.patch
  ]

* Fri Nov 10 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 5.0-7
- disable check for loongarch64

* Tue Nov  7 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 5.0-6
- add loongarch64 support for debugedit

* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> -5.0-5
- Optimize spec file

* Sun Feb 26 2023 Funda Wang <fundawang@yeah.net> - 5.0-4
- Sync with upstream patches

* Wed Feb 08 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 5.0-3
- Add abi file

* Sat Oct 08 2022 mgb01105731 <mgb01105731@alibaba0inc.com> - 5.0-2
- add doc package

* Fri May 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.0-1
- init from upstream
